<template>
  <div style="display: flex; justify-content: center">
    <div
      v-for="(story, j) of stories"
      :key="j"
      v-show="story.isActive"
      v-touch:start="start"
      v-touch:end="end"
      v-touch:swipe.left="swipeleft"
      v-touch:swipe.right="swiperight"
      class="story"
    >
      <div class="story-content">
        <div class="timeline">
          <div class="slice" v-for="(slide, i) in story.slides" :key="i">
            <div class="progress">&nbsp;</div>
          </div>
        </div>
        <div class="avatar-cont">
          <div class="img-cont">
            <img class="avatar-img" :src="story.avatar" alt="" />
            <div class="avatar-text">{{ story.title }}</div>
          </div>
          <div>
            <button @click="deactivate()" type="button" class="close">
              <img src="~/assets/icons/close.svg" alt="close" />
            </button>
          </div>
        </div>
      </div>
      <div class="footer-cont" :style="{ background: story.backcolor }">
        <div class="btn-container">
          <img src="~/assets/icons/up-chevron.svg" alt="" />
          <ExtLink :linkProps="story.link" class="story-btn" :style="story.linkStyle">
            {{ story.linkTitle }}
          </ExtLink>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { EventBus } from "~/helpers/EventBus.js";
import ExtLink from "../../../components/main/ExtLink"
const SLIDE_DURATION = 20;
export default {
  name: "StoryScreen",
  components:{
    ExtLink
  },
  data() {
    return {
      i: 0,
      inter: null,
      progress: null,
      endTime: 0,
      startTime: 0,
      currentSlideIndex: 0,
      currentStoryIndex: 0,
      stories: [
        {
          isActive: false,
          title: "ThorWallet",
          linkTitle: "Let's See it!",
          link: this.$links('stories_thorwallet_web_app'),
          avatar: require("~/assets/images/home-page/stories/big/big_avatar_thorchain_mccn.svg"),
          slides: [
            require("~/assets/images/home-page/stories/big/big_card_thorwallet.svg"),
          ],
          linkStyle: "background-color: #000; color: #FFF;",
          // backcolor: "#fff",
        },
        {
          isActive: false,
          title: "Kraken X THORChain",
          linkTitle: "Native Rune on Kraken",
          link: this.$links('stories_kraken_listed'),
          avatar: require("~/assets/images/home-page/stories/big/big_avatar_kraken.svg"),
          slides: [
            require("~/assets/images/home-page/stories/big/big_card_kraken.svg"),
          ],
          linkStyle: "background-color: #5841D8; color: #FFF;",
          // backcolor: "#fff",
        },
        {
          isActive: false,
          title: "SKIP",
          linkTitle: "Try SKIP",
          link: this.$links('stories_skip_web_app'),
          avatar: require("~/assets/images/home-page/stories/big/big_avatar_skip.svg"),
          slides: [
            require("~/assets/images/home-page/stories/big/big_card_skip.svg"),
          ],
          linkStyle: "background-color: #28F4AE; color: black;",
          // backcolor: "#fff",
        },
      ],
    };
  },
  methods: {
    start() {
      clearInterval(this.progress);
      clearInterval(this.inter);
      this.endTime = new Date();
    },
    swipeleft() {
      clearInterval(this.inter);
      clearInterval(this.progress);
      console.log("swipe left");
      this.nextSlide();
    },
    swiperight() {
      console.log("swipe right");
      this.previousStory();
    },
    end() {
      var remained = SLIDE_DURATION * 1010 - (this.endTime - this.startTime);
      this.inter = setInterval(() => {
        this.startTime = new Date();
        // console.log("Interval");
        this.nextSlide();
      }, remained);
      this.startTime = new Date();
      this.progress = setInterval(() => {
        this.i = this.i + 0.25;
        document
          .getElementsByClassName("timeline")
          [this.currentStoryIndex].getElementsByClassName("slice")
          [this.currentSlideIndex].getElementsByClassName(
            "progress"
          )[0].style.width = this.i + "%";
        // console.log(this.i);
        if (this.i >= 100) clearInterval(this.progress);
      }, 50);
    },
    activate(storyNumber) {
          // console.log("StoryScreen: Story Card activated")
          this.$store.commit('isStoryCardOpen', true)

          this.stories[storyNumber].isActive = true;
          this.currentStoryIndex = storyNumber;
          this.currentSlideIndex = 0;
          this.init();
    },
    deactivate() {
      // console.log("StoryScreen: Story Card deactivated")
      this.$store.commit('isStoryCardOpen', false)

      this.stories[this.currentStoryIndex].isActive = false;
      clearInterval(this.inter);
      clearInterval(this.progress);
    },
    nextSlide() {
      if (
        this.currentSlideIndex <
        this.stories[this.currentStoryIndex].slides.length - 1
      ) {
        this.currentSlideIndex++;
        document.getElementsByClassName("story-content")[
          this.currentStoryIndex
        ].style.background =
          "url('" +
          this.stories[this.currentStoryIndex].slides[this.currentSlideIndex] +
          "')";
        this.i = 0;
        this.progress = setInterval(() => {
          this.i = this.i + 0.25;
          document
            .getElementsByClassName("timeline")
            [this.currentStoryIndex].getElementsByClassName("slice")
            [this.currentSlideIndex].getElementsByClassName(
              "progress"
            )[0].style.width = this.i + "%";
          // console.log(this.i);
          if (this.i >= 100) clearInterval(this.progress);
        }, 50);
      } else if (this.currentStoryIndex < this.stories.length - 1) {
        this.nextStory();
      } else {
        this.deactivate();
      }
    },
    previousStory() {
      clearInterval(this.inter);
      clearInterval(this.progress);
      if (this.currentStoryIndex > 0) {
        this.deactivate();
        this.currentStoryIndex--;
        this.currentSlideIndex = 0;
        this.stories[this.currentStoryIndex].isActive = true;
        this.init();
      } else {
        this.deactivate();
      }
    },
    nextStory() {
      clearInterval(this.progress);
      this.stories[this.currentStoryIndex].isActive = false;
      this.currentStoryIndex++;
      this.currentSlideIndex = 0;
      this.stories[this.currentStoryIndex].isActive = true;
      this.i = 0;
      this.progress = setInterval(() => {
        //
        this.i = this.i + 0.25;
        document
          .getElementsByClassName("timeline")
          [this.currentStoryIndex].getElementsByClassName("slice")
          [this.currentSlideIndex].getElementsByClassName(
            "progress"
          )[0].style.width = this.i + "%";
        // console.log(this.i);
        //
        if (this.i >= 100) clearInterval(this.progress);
      }, 50);
      document.getElementsByClassName("story-content")[
        this.currentStoryIndex
      ].style.backgroundImage =
        "url('" +
        this.stories[this.currentStoryIndex].slides[this.currentSlideIndex] +
        "')";
    },
    init() {
      this.startTime = new Date();
      clearInterval(this.progress);
      document.getElementsByClassName("story-content")[
        this.currentStoryIndex
      ].style.backgroundImage =
        "url('" +
        this.stories[this.currentStoryIndex].slides[this.currentSlideIndex] +
        "')";
      this.i = 0;

      this.progress = setInterval(() => {
        this.i = this.i + 0.25;
        document
          .getElementsByClassName("timeline")
          [this.currentStoryIndex].getElementsByClassName("slice")
          [this.currentSlideIndex].getElementsByClassName(
            "progress"
          )[0].style.width = this.i + "%";
        // console.log(this.i);
        if (this.i >= 100) {
          clearInterval(this.progress);
          // console.log("finished");
        }
      }, 50);

      this.inter = setInterval(() => {
        this.startTime = new Date();
        // console.log("Interval");
        this.nextSlide();
      }, SLIDE_DURATION * 1010);
    },
  },
  mounted() {
    EventBus.$on("ACTIVATE_STORY", (story) => {
      this.activate(story);
    });
  }
};
</script>

<style scoped>
.footer-cont {
  height: 100px;
  background: #000b12;
  justify-content: center;
  display: flex;
  color: white;
  position: relative;
}
.link-title {
  font-family: Roboto;
  font-style: normal;
  font-weight: bold;
  font-size: 15px;
  line-height: 18px;
  letter-spacing: -0.175px;
}
.footer-cont > .btn-container > .story-btn {
  width: 90vw;
  height: 40px;
  border: none;
  border-radius: 6px;
  font-weight: 700;
  display: flex;
  justify-content: center;
  align-items: center;
}
.footer-cont > .btn-container {
  display: flex;
  flex-direction: column;
  align-items: center;
  bottom: 10px;
  position: fixed;
}

.footer-cont > .btn-container > img {
  width: 15px;
  color: #fff;
  padding-bottom: 10px;
}
.avatar-cont {
  display: flex;
  align-items: center;
  margin-inline: 10px;
  justify-content: space-between;
}
.img-cont > .avatar-text {
  margin-left: 10px;
  font-family: Roboto;
  font-style: normal;
  font-weight: bold;
  font-size: 14px;
  line-height: 16px;
  letter-spacing: -0.163333px;
  color: #fff;
  text-shadow: 0px 1px 1px rgba(0, 0, 0, 0.582359);
}
.img-cont > .avatar-img {
  width: 36px;
  height: 36px;
}
.avatar-cont > .img-cont {
  display: flex;
  align-items: center;
  font-family: Roboto;
}
.close > button {
  align-items: center;
  display: flex;
}
.close > span {
  font-size: 25px;
  color: white;
}
.story {
  float: left;
  position: fixed;
  top: 0;
  height: 100vh;
  width: 100vw;
  z-index: 50000;
  display: flex;
  flex-direction: column;
}
.story > .story-content {
  height: 90vh;
  width: 100vw;
  background-position: center;
  background-size: cover;
}
.story > .close {
  width: 30px;
  height: 30px;
}

.timeline {
  display: flex;
  flex-grow: 0;
  width: 100%;
  border-radius: 20%;
}

.timeline > .slice {
  background: #a5a0a0;
  height: 1px;
  margin: 10px;
  width: 100%;
  border-radius: 20%;
}

.timeline > .slice > .progress {
  background: rgb(243, 243, 243);
  height: 1px;
  width: 0;
  border-radius: 20%;
}

.slide {
  flex-grow: 1;
  display: flex;
  align-items: center;
  justify-content: center;
}

.slide p {
  font-size: 60px;
  opacity: 0.5;
}
</style>
